<!--#include virtual="/Common/Includes/Common.asp"-->
<!--#include virtual="/Common/Includes/Header.asp"-->
<!-- Start:	Body Content -->
<table Class="InnerTable" vAlign="top" Border="1" CellPadding="1" CellSpacing="1" Width="100%" Height="100%">
	<tbody><!-- Start:	Items -->
	<tr>
		<td>
		<!--Main Body of Document goes Below -->
			<table Class="InnerTable" width="100%">
				<tr>
					<td vAlign="top" width="100%">
						<!--Begin Content-->
						<table border="0" cellPadding="0" cellSpacing="0" width="100%">
							<tbody>
							<tr><td colSpan="2" vAlign="top" width="100%"><hr></td></tr>
							<tr>
								<td align="left" noWrap vAlign="top">
									<span class="SmallBodyText">&nbsp;Advanced Revelation Products&nbsp;</span>
								</td>
								<td align="right" width="100%">
									<font class="SmallBodyText" size="2">
									No concern to Windows Based Products
									</font>
								</td>
							</tr>
							</tbody>
						</table>
						<table border="0" cellPadding="1" cellSpacing="0" width="100%">
							<tbody>
							<!-- Start of Items -->
							<tr>
								<td align="right" rowSpan="7" vAlign="top" width="106">
									<span class="SmallBodyText"><img SRC="<%=ROOT%>images/Common/Y2k.gif" border="0" alt="Y2k Issues" WIDTH="40" HEIGHT="40"></span>
								</td>
								<td></td>
								<td align="middle" class="SmallBodyText" vAlign="top">&nbsp;&#149;</td>
								<td vAlign="top">
									<span class="SmallBodyText"><a href="http://www.y2k.com" target="_New">More information on Y2k issues</a></span>
									<nobr>
									<span class="Whisper">(External Link)</span>
									</nobr>
								</td>
							</tr>
							<tr>
								<td></td>
								<td align="middle" class="clsLND" vAlign="top">&nbsp;&#149;</td>
								<td vAlign="top">
									<span class="SmallBodyText"><a href="http://www.revelation.com" target="_New">Revelation Technologies home site.</a></span>
									<nobr>
									<span class="Whisper">(External Link)</span>
									</nobr>
								</td>
							</tr>
							<!-- End of Items -->
							</tbody>
						</table>
						</span>
						<!-- End of Category -->
						<hr>
						<table Class="InnerTable" border="1" Width="100%">
							<tr>
								<td Class="InnerContent" vAlign="top">
									<i>Note: This document is provided only as a guide. Nobody takes responsibility for how you use this document. This information is provided only to serve as an outline of Year 2000 issues.</i> 
									<p><b>The Year 2000 Problem</b><br>
									<p><b>What Is It?</b> 
									<p>When you receive your new credit card with an expiration date of '01, you know that means it will expire in the year 2001.
									Many computer systems, however, will assume that '01 means <b>19</b>01, and automatically generate overdue notices, for example.
									Other computer systems won't be able to accept the information at all, preventing any processing whatsoever.
									Obviously, this is a big problem.
									<p><b>How Did This Happen?</b> 
									<p>In the early years of computing, capacity (CPU cycles, memory, and disk space) was limited.
									Including the first two digits of a four-digit year required an extra two bytes each occurrence.
									At that point, the 1960s, the end of the 20th century was far enough in the future so as not to be an issue.
									Over the next two decades, CPU cycles improved but memory and disk space continued to be expensive.
									In the 1990s, these resources are no longer scarce, and longsighted programmers with &quot;good&quot; programming habits are using four-digits years to prevent this problem.
									Many programs and systems in use today, however, were implemented in the 1960s-1980s before the four-digit year was &quot;affordable&quot; and must be &quot;retro-fitted&quot; to allow for the four-digit year.<br>
									<p><b>Where Is the Problem?</b> 
									<p>Not only is the Year 2000 problem potentially very serious, it is also extremely complex because there are many places in which the problem can be lurking:
									<li>In various types of <b>software</b> including:
									<li>applications (line-of-business, functional)
									<li>vendor packages (productivity tools, operating systems, development tools, office suites, etc.)
									<li>data files
									<li>In various types of <b>hardware</b>, including:
									<li>information systems hardware (computers, printers, routers, peripherals, etc.)
									<li>non-information systems hardware (ATM machines, fax machines, elevators, satellites, etc.)
									<br>To further compound the problem, there are  many ways in which the Year 2000 problem can manifest itself.
										Below is a partial list of date-related problems:
									<li>Century ambiguity - this occurs when dates are represented with only two digits. This can cause a variety of problems including:
									<li>The rejection of any 20xx dates as invalid. 
									<li>The inability to allow for the entry of four-digit years (user interface).
									<li>Incorrect sorting of a list of dates that include both 19xx and 20xx years.
									<li>Incorrect calculation of periods when the period spans the millenium rollover.
									<li>Extended semantics - some systems use interpret specific date entries differently; for example a date of &quot;99&quot; in an expiration date field might be used to represent &quot;does not expire.&quot;
									<li>Calendar errors - systems that do not correctly account for leap years (including the year 2000) will incorrectly calculate the weekday (for example, after February 28, 2000).
									<li>Date overflow - some systems store dates as a base date/time plus an offset in days/seconds/etc. passed since that initial date.
										This &quot;offset value&quot; is represented in a fixed-length integer.
										After a period of time, the offset value will require an integer of greater length.
									<li>Inconsistent semantics - when two or more systems are interfaced, but the same-century assumptions made about two-digit years are different (for example 67-99 are interpreted as 1967-1999 but 00-66 are interpreted as 2000-2066), there will be problems.<br>

									<p><b>FailSafe Products and the Year 2000</b> 
									<p>There are two major categories of Year 2000 issues pertaining to FailSafe Products's suite of products:</p>
									<li>FailSafe Products themselves
									<li>Applications developed <b>using</b> Advanced Revelation

									<p>The following information outlines Year 2000 issues pertaining to FailSafe Products in and of themselves.
									FailSafe Products is unique in that the <b>storage</b> of data is separate from the <b>display</b> of data.
									<p><b>Storage</b> 
									<p>Date values (including the date portion of date/time values) in FailSafe Products is stored as integer values, not as fixed length year, month, and day fields.
									The integer storage value is the number of days that have passed since the system's &quot;zero date&quot; (December 31, 1967); dates previous to the zero date are stored as negative integers.
									Storage of date values in FailSafe Products will not be a problem for another 5 million years.
									It is important to ensure that all dates are, in fact, stored in date format.
									If no format is specified for a date field, the data will be stored as a character string, and will not be treated as a date.
									For example, a properly defined date field will store the date 1/1/98 as the integer 10959 but if the field has not been defined as a date field, the data will be stored as the character string &quot;1/1/98.&quot; 
									<p><b>Display</b> 
									<p>To avoid ambiguity when displaying date values, you should always use a four-digit year format.
									The default format, &quot;D&quot;, uses the four-digit year, and four digits will always be displayed unless the number of digits is overridden; the &quot;D2/&quot; format, for example, displays the date in the format &quot;dd/mm/yy&quot;, and is very popular in the United States.
									Using a four-digit year format, display of date values in FailSafe Products will not be a problem for another 8 thousand years.
									The data dictionaries define the defaults for data input/output display.
									Multiple dictionary items can be created for the same piece of data to provide multiple display formats.
									Because the dictionary item is separate from the storage of the data, the format can be changed without affecting the data itself. 
									Forms, reports and programs will default to the date display format defined in the data dictionary; however they may also override this default.
									To ensure Year 2000 compliance, all date fields in the dictionary should be changed to a D4 format. Then any forms, reports, or programs that override dictionary defaults should be checked to ensure they, too, are in D4 format.
									<p><b>Data Entry</b> 
									<p>Most dates are entered with either no year or with a two-digit year.
									Dates entered without a year default to the current year.
									Dates entered with a two-digit year are subject to the following rule:
									For year values between 0 and 29 inclusive, the year is assumed to be after 2000,
									and for years between 30 and 99 inclusive, the year is assumed to be prior to 2000.
									This assumption is meant to assist in data entry during the years when dates being entered are from either the twentieth or twenty-first centuries.
									It is recommended that date display be changed to the D4 four-digit) format and input mask and validation be place on the field to require four-digit year input, to prevent user error.
									It is also possible to write a program that will cause dates entered with a two-digit year to default differently than currently defined.
									You need to make sure that the first two digits of a four-digit year have not been hard-coded in your application.
									FailSafe Products also correctly accounts for leap years, including the rule exceptions for leap centuries and every fourth leap century.

									<br><br>Applications <b>developed by</b> FailSafe Systems may include Year 2000 problems not outlined above.
									<p><b>Where Can I Get Help?</b> 
									<p>If you need technical assistance in assessing Year 2000 compliance with our products, FailSafe Software has a the expertise that can help you.
									<br><br>There are also a whole host of legal issues surrounding Year 2000 compliance.
									You are advised to consult with your own legal counsel in all legal matters.
									<br><br><b>Appendix 1: FailSafe Products and Year 2000 issues</b>
									<br><i>Note: this table is not intended to be an exhaustive list of potential problem areas.</i>
									<br>
									<table Class="InnerTable" border="1" cellpadding="3" cellspacing="0" width="100%">
										<tbody>
											<tr vAlign="top">
												<th Class="InnerHeaderAlt" width="25%"><b>Type of problem</b></th>
												<th Class="InnerHeaderAlt" width="25%"><b>Manifestation of problem</b></th>
												<th Class="InnerHeaderAlt" width="25%"><b>FailSafe Products (all versions)</b></th>
												<th Class="InnerHeaderAlt" width="25%"><b>FailSafe Applications (all versions)</b></th>
											</tr>
											<tr vAlign="top">
												<th Class="InnerHeader" rowspan="4">Century ambiguity</th>
												<td Class="InnerContentAlt">The rejection of any 20xx dates as invalid</td>
												<td Class="InnerContentAlt">Because FailSafe Products use an integer to store dates as an &quot;offset value&quot; (positive and negative), they will not reject any dates as invalid.</td>
												<td Class="InnerContentAlt">Ensure there is no application logic that rejects dates.</td></tr>
											<tr vAlign="top">
												<td Class="InnerContentAlt">The inability to allow for the entry of four-digit years (user interface </td>
												<td Class="InnerContentAlt">FailSafe Products allow for the entry of four-digit years. </td>
												<td Class="InnerContentAlt">If the user interface currently allows only for two-digit year input, it can be changed without corruption to enable four-digit year input.</td>
											</tr>
											<tr vAlign="top">
												<td Class="InnerContentAlt">Sorting of a list of dates that include both 19xx and 20xx years</td>
												<td Class="InnerContentAlt">Because FailSafe Products store dates as an integer, years will be correctly sorted.</td>
												<td Class="InnerContentAlt">Ensure that all date values are stored in date format and that all dates are right-justified.</td>
											</tr>
											<tr vAlign="top">
												<td Class="InnerContentAlt">Incorrect calculation of periods when the period spans the millenium rollover</td>
												<td Class="InnerContentAlt">Because FailSafe Products store dates as an integer, periods will be correctly calculated.</td>
												<td Class="InnerContentAlt">Ensure that all date values are stored in date format and that all dates are right-justified.</td>
											</tr>
											<tr vAlign="top">
												<th Class="InnerHeader">Extended semantics</th>
												<td Class="InnerContentAlt">Specific values for date fields reserved for special interpretation</td>
												<td Class="InnerContentAlt">No specific values are reserved for special interpretation.</td>
												<td Class="InnerContentAlt">Ensure there are no programs that reserve any date values for special interpretation.</td>
											</tr>
											<tr vAlign="top">
												<th Class="InnerHeader">Calendar errors</th>
												<td Class="InnerContentAlt">Incorrect accounting for leap years</td>
												<td Class="InnerContentAlt">FailSafe Products correctly account for leap years.</td>
												<td Class="InnerContentAlt">Ensure that all date values are stored in date format.</td>
											</tr>
											<tr vAlign="top">
												<th Class="InnerHeader">Date overflow</th>
												<td Class="InnerContentAlt">Fixed-length integer not sufficient to represent the date</td>
												<td Class="InnerContentAlt">Date overflow will not be a problem for another 5 million years</td>
												<td Class="InnerContentAlt">not applicable</td>
											</tr>
											<tr vAlign="top">
												<th Class="InnerHeader">Inconsistent semantics</th>
												<td Class="InnerContentAlt">Interface of multiple systems that make different same-year assumptions</td>
												<td Class="InnerContentAlt">For year values between 0 and 29 inclusive, the year is assumed to be 2000-2029, and for years between 30 and 99 inclusive, the year is assumed to 1930-1999.</td>
												<td Class="InnerContentAlt">Ensure that any other interfacing systems assume values between 0 and 29 to be 2000-2029, and years between 30 and 99 to be 1930-1999. If this is not the case, a four-digit year must be used.</td>
											</tr>
											<tr><th Class="InnerHeaderAlt" colspan="4">In closing let it be stated categorically that unless we have visited your site and done a full System Analysis we cannot GUARANTEE the Y2k Compliancy of your Software.</th></tr>
										</tbody>
									</table>
								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	</tbody><!-- End:	Items -->
</table>
<!-- End:	Body Content -->
<div id="KeyWords" style="visibility: hidden; height: 1px">
	<!-- SEARCH INDEX KEYWORDS -->
	FailSafe Stylis TimeSafe Brian Gillham Software Developer Products Advanced Revelation
</div>
<!--#include virtual="/Common/Includes/Footer.asp"-->
