<%
'***********************************************
'    UTE - (U)niversal ASP (T)able (E)ditor
'***********************************************
' ADOLIB.INC                           Rev.: 1.4
' Some usefull ADO functions
'                                               
' (c) in 2000-2001 by Tom Wellige                    
' http://www.wellige.com , tom@wellige.com     
'                                               
' You may use and alter this script as long as  
' you put this original header in it !          
'                                               
'***********************************************

' Microsofts ADOVBS.INC must be included before !!!


'---- Additional DataTypeEnum Values ----
Const adChapter = 136
Const adPropVariant = 138


'
' These field types won't be displayed
' and are not editable
'
dim etCnt
dim ExcludeTypes()

etCnt = 0

Sub AddExcludeType ( nType )
  etCnt = etCnt + 1
  Redim Preserve ExcludeTypes(etCnt)
  ExcludeTypes(etCnt) = nType
End Sub

AddExcludeType adEmpty            ' 0
AddExcludeType adError            ' 10
AddExcludeType adUserDefined      ' 132
AddExcludeType adVariant          ' 12
AddExcludeType adIDispatch        ' 9
AddExcludeType adIUnknown         ' 13
AddExcludeType adBinary           ' 128
AddExcludeType adVarBinary        ' 204
AddExcludeType adLongVarBinary    ' 205
AddExcludeType adChapter          ' 136
AddExcludeType adPropVariant      ' 138


'
' Returns the Type of an ADODB.Field as string
'
function GetTypeString(iType)
  dim sReturn
  select case iType
    case adEmpty
      sReturn = "Empty"
    case adTinyInt
      sReturn = "TinyInt"
    case adSmallInt
      sReturn = "SmallInt"
    case adInteger
      sReturn = "Integer"
    case adBigInt
      sReturn = "BigInt"
    case adUnsignedTinyInt
      sReturn = "UnsignedTinyInt"
    case adUnsignedSmallInt
      sReturn = "UnsignedSmallInt"
    case adUnsignedInt
      sReturn = "UnsignedInt"
    case adUnsignedBigInt
      sReturn = "UnsignedBigInt"
    case adSingle
      sReturn = "Single"
    case adDouble
      sReturn = "Double"
    case adCurrency
      sReturn = "Currency"
    case adDecimal
      sReturn = "Decimal"
    case adNumeric
      sReturn = "Numeric"
    case adBoolean
      sReturn = "Boolean"
    case adError
      sReturn = "Error"
    case adUserDefined
      sReturn = "UserDefined"
    case adVariant
      sReturn = "Variant"
    case adIDispatch
      sReturn = "IDispatch"
    case adIUnknown
      sReturn = "IUnknown"
    case adGUID
      sReturn = "GUID"
    case adDBDate
      sReturn = "DBDate"
    case adDBTime
      sReturn = "DBTime"
    case adDBTimeStamp
      sReturn = "DBTimeStamp"
    case adBSTR
      sReturn = "BSTR"
    case adChar
      sReturn = "Char"
    case adVarChar
      sReturn = "VarChar"
    case adLongVarChar
      sReturn = "LongVarChar"
    case adWChar
      sReturn = "WChar"
    case adVarWChar
      sReturn = "VarWChar"
    case adLongVarWChar
      sReturn = "LongVarWChar"
    case adBinary
      sReturn = "Binary"
    case adVarBinary
      sReturn = "VarBinary"
    case adLongVarBinary
      sReturn = "LongVarBinary"
    case adChapter
      sReturn = "Chapter"
    case adPropVariant
      sReturn = "PropVariant"
    case else
      sReturn = "Unknown"
  end select

  GetTypeString = sReturn

end function


'
' Returns the Attributes of an ADODB.Field as string
'
function GetAttributesString(nAttrib)
  dim sReturn
  sReturn = ""
  if (nAttrib and adFldMayDefer) then sReturn = sReturn & "MayDefer, "
  if (nAttrib and adFldUpdatable) then sReturn = sReturn & "Updatable, "
  if (nAttrib and adFldUnknownUpdatable) then sReturn = sReturn & "UnknownUpdatable, "
  if (nAttrib and adFldFixed) then sReturn = sReturn & "Fixed, "
  if (nAttrib and adFldIsNullable) then sReturn = sReturn & "IsNullable, "
  if (nAttrib and adFldMayBeNull) then sReturn = sReturn & "MayBeNull, "
  if (nAttrib and adFldLong) then sReturn = sReturn & "Long, "
  if (nAttrib and adFldRowID) then sReturn = sReturn & "RowID, "
  if (nAttrib and adFldRowVersion) then sReturn = sReturn & "RowVersion, "
  if (nAttrib and adFldCacheDeferred) then sReturn = sReturn & "CacheDeferred, "
  if sReturn <> "" then sReturn = Left(sReturn, Len(sReturn)-2)

  GetAttributesString = sReturn

end function


'
' Checks, if a specified attribute is set
'
function Attrib(nField, nAttrib)

  Attrib = (nField and nAttrib)
  
end function


'
' Checks, if a specified attribute is not set
'
function NotAttrib(nField, nAttrib)

  if Attrib(nField, nAttrib) then
    NotAttrib = false
  else
    NotAttrib = true
  end if
  
end function


'
' Checks, if given Type is in Exclude List
'
function IsExcluded( nType )
  bReturn = false
  for ii = 1 to etCnt
    if nType = ExcludeTypes(ii) then bReturn = True
  next
  IsExcluded = bReturn
end function

%>